<?php

class Region
{
    public $x1 = 0;
    public $y1 = 0;
    public $x2 = 0;
    public $y2 = 0;

    public function width()
    {
        return $this->x2 - $this->x1;
    }

    public function height()
    {
        return $this->y2 - $this->y1;
    }

    public function set($x, $y, $width, $height)
    {
        $this->x1 = $x;
        $this->y1 = $y;
        $this->x2 = $x + $width;
        $this->y2 = $y + $height;
    }

    public function merge($x, $y, $width, $height)
    {
        $x1 = $x;
        $y1 = $y;
        $x2 = $x + $width;
        $y2 = $y + $height;

        if ($this->x2 > $this->x1 && $this->y2 > $this->y1) {
            if ( $x1 < $this->x1 ) {
                $this->x1 = $x1;
            }
            if ( $y1 < $this->y1 ) {
                $this->y1 = $y1;
            }
            if ( $x2 > $this->x2 ) {
                $this->x2 = $x2;
            }
            if ( $y2 > $this->y2 ) {
                $this->y2 = $y2;
            }
        } else {
            $this->x1 = $x1;
            $this->y1 = $y1;
            $this->x2 = $x2;
            $this->y2 = $y2;
        }

    }
}

